Index: /trunk/src/lib/network/network_stream.cc
===================================================================
--- /trunk/src/lib/network/network_stream.cc	(revision 9493)
+++ /trunk/src/lib/network/network_stream.cc	(revision 9494)
@@ -65,5 +65,5 @@
   this->init();
   /* initialize the references */
-  this->pInfo->nodeType = NET_CLIENT;
+  this->pInfo->nodeType = NET_UNASSIGNED;
 }
 
@@ -79,20 +79,16 @@
     case NET_MASTER_SERVER:
       // init the shared network data
-      SharedNetworkData::getInstance()->setHostID(0);
-//       SharedNetworkData::getInstance()->setNodeType(NET_MASTER_SERVER);
+      SharedNetworkData::getInstance()->setHostID(NET_ID_MASTER_SERVER);
       break;
-
     case NET_PROXY_SERVER_ACTIVE:
       // init the shared network data
-      SharedNetworkData::getInstance()->setHostID(0);
-//       SharedNetworkData::getInstance()->setNodeType(NET_PROXY_SERVER_ACTIVE);
+      SharedNetworkData::getInstance()->setHostID(NET_ID_PROXY_SERVER_01);
       break;
     case NET_PROXY_SERVER_PASSIVE:
-            // init the shared network data
-      SharedNetworkData::getInstance()->setHostID(0);
-//       SharedNetworkData::getInstance()->setNodeType(NET_PROXY_SERVER_PASSIVE);
+      // init the shared network data
+      SharedNetworkData::getInstance()->setHostID(NET_ID_PROXY_SERVER_01);
       break;
     case NET_CLIENT:
-//       SharedNetworkData::getInstance()->setNodeType(NET_CLIENT);
+      SharedNetworkData::getInstance()->setHostID(NET_ID_UNASSIGNED);
       break;
   }
@@ -115,5 +111,6 @@
   /* set the class id for the base object */
   this->setClassID(CL_NETWORK_STREAM, "NetworkStream");
-  this->serverSocket = NULL;
+  this->clientSocket = NULL;
+  this->proxySocket = NULL;
   this->networkGameManager = NULL;
   this->networkMonitor = NULL;
@@ -124,4 +121,5 @@
   this->pInfo->lastRecvedState = 0;
 
+  this->bRedirect = false;
 
   this->currentState = 0;
@@ -142,9 +140,15 @@
 NetworkStream::~NetworkStream()
 {
-  if ( this->serverSocket )
-  {
-    serverSocket->close();
-    delete serverSocket;
-    serverSocket = NULL;
+  if ( this->clientSocket )
+  {
+    clientSocket->close();
+    delete clientSocket;
+    clientSocket = NULL;
+  }
+  if ( this->proxySocket)
+  {
+    proxySocket->close();
+    delete proxySocket;
+    proxySocket = NULL;
   }
   for ( PeerList::iterator i = peers.begin(); i!=peers.end(); i++)
@@ -187,10 +191,11 @@
 void NetworkStream::connectToMasterServer(std::string host, int port)
 {
-  int node = this->peers.size();
+  int node = NET_ID_MASTER_SERVER;
+  // this create the new node in the peers map
   this->peers[node].socket = new UdpSocket( host, port );
-  this->peers[node].userId = 0;
+  this->peers[node].userId = NET_ID_MASTER_SERVER;
 
   this->peers[node].nodeType = NET_MASTER_SERVER;
-  this->peers[node].connectionMonitor = new ConnectionMonitor( 0 );
+  this->peers[node].connectionMonitor = new ConnectionMonitor( NET_ID_MASTER_SERVER );
   this->peers[node].ip = this->peers[node].socket->getRemoteAddress();
 }
@@ -202,13 +207,15 @@
  * @param port: the port number
  */
-void NetworkStream::connectToProxyServer(std::string host, int port)
-{
-  int node = this->peers.size();
-  this->peers[node].socket = new UdpSocket( host, port );
-  this->peers[node].userId = 0;
-
-  this->peers[node].nodeType = NET_PROXY_SERVER_ACTIVE;
-  this->peers[node].connectionMonitor = new ConnectionMonitor( 0 );
-  this->peers[node].ip = this->peers[node].socket->getRemoteAddress();
+void NetworkStream::connectToProxyServer(int proxyId, std::string host, int port)
+{
+  PRINTF(0)("connect to proxy %s, this is proxyId %i\n", host.c_str(), proxyId);
+
+  // this creates the new proxyId in the peers map
+  this->peers[proxyId].socket = new UdpSocket( host, port );
+  this->peers[proxyId].userId = proxyId;
+
+  this->peers[proxyId].nodeType = NET_PROXY_SERVER_ACTIVE;
+  this->peers[proxyId].connectionMonitor = new ConnectionMonitor( proxyId );
+  this->peers[proxyId].ip = this->peers[proxyId].socket->getRemoteAddress();
 }
 
@@ -218,7 +225,9 @@
  * @param port: interface port for all clients
  */
-void NetworkStream::createServer(int port)
-{
-  this->serverSocket = new UdpServerSocket(port);
+void NetworkStream::createServer(int clientPort, int proxyPort)
+{
+  PRINTF(0)(" Creating new Server: listening for clients on port %i and for proxies on port %i", clientPort, proxyPort);
+  this->clientSocket= new UdpServerSocket(clientPort);
+  this->proxySocket = new UdpServerSocket(proxyPort);
 }
 
@@ -240,11 +249,13 @@
  * handsakes are always initialized from the client side first. this starts the handshake and therefore is only
  * executed as client
- */
-void NetworkStream::startHandshake()
+ * @param userId: start handshake for this user id (optional, default == 0)
+ */
+void NetworkStream::startHandshake(int userId)
 {
   Handshake* hs = new Handshake(this->pInfo->nodeType);
-  hs->setUniqueID( 0 );
-  assert( peers[0].handshake == NULL );
-  peers[0].handshake = hs;
+  // fake the unique id
+  hs->setUniqueID( NET_UID_HANDSHAKE );
+  assert( peers[userId].handshake == NULL );
+  peers[userId].handshake = hs;
 
   // set the preferred nick name
@@ -259,4 +270,5 @@
  * it all over the network and creating it on the other platforms (if and only if it is a
  * server
+ * @param sync: the synchronizeable to add
  */
 void NetworkStream::connectSynchronizeable(Synchronizeable& sync)
@@ -264,6 +276,4 @@
   this->synchronizeables.push_back(&sync);
   sync.setNetworkStream( this );
-
-//   this->bActive = true;
 }
 
@@ -271,4 +281,5 @@
 /**
  * removes the synchronizeable from the list of synchronized entities
+ * @param sync: the syncronizeable to remove
  */
 void NetworkStream::disconnectSynchronizeable(Synchronizeable& sync)
@@ -302,43 +313,45 @@
   }
 
-  if ( this->pInfo->isMasterServer())
+  if ( SharedNetworkData::getInstance()->isMasterServer())
   {
     // execute everytthing the master server shoudl do
-    if ( serverSocket )
-      serverSocket->update();
+    if ( this->clientSocket )
+      this->clientSocket->update();
+    if( this->proxySocket)
+      this->proxySocket->update();
 
     this->updateConnectionList();
   }
-  else if( this->pInfo->isProxyServer())
-  {
-    // execute everything the proxy server should do
-    if ( serverSocket )
-      serverSocket->update();
+  else if( SharedNetworkData::getInstance()->isProxyServerActive())
+  {
+    //execute everything the proxy server should do
+    if ( this->clientSocket )
+      this->clientSocket->update();
+    if( this->proxySocket)
+      this->proxySocket->update();
 
     this->updateConnectionList();
   }
-  else
+
+#warning make this more modular: every proxy/master server connection should be watched for termination
+  if( !SharedNetworkData::getInstance()->isMasterServer())
   {
     // check if the connection is ok else terminate and remove
-    if ( peers[0].socket && ( !peers[0].socket->isOk() || peers[0].connectionMonitor->hasTimedOut() ) )
-    {
+    if ( !peers.empty() && peers[NET_ID_MASTER_SERVER].socket &&
+          ( !peers[NET_ID_MASTER_SERVER].socket->isOk() ||
+          peers[NET_ID_MASTER_SERVER].connectionMonitor->hasTimedOut() ) )
+    {
+      this->handleDisconnect( NET_ID_MASTER_SERVER);
       PRINTF(1)("lost connection to server\n");
-
-      peers[0].socket->disconnectServer();
-      delete peers[0].socket;
-      peers[0].socket = NULL;
-
-      if ( peers[0].handshake )
-        delete peers[0].handshake;
-      peers[0].handshake = NULL;
-
-      if ( peers[0].connectionMonitor )
-        delete peers[0].connectionMonitor;
-      peers[0].connectionMonitor = NULL;
-    }
-  }
-
-  cleanUpOldSyncList();
-  handleHandshakes();
+    }
+    // check if there is a redirection command
+    if( this->bRedirect)
+    {
+      this->handleReconnect( NET_ID_MASTER_SERVER);
+    }
+  }
+
+  this->cleanUpOldSyncList();
+  this->handleHandshakes();
 
   // update the network monitor
@@ -347,12 +360,14 @@
   // order of up/downstream is important!!!!
   // don't change it
-  handleDownstream( tick );
-  handleUpstream( tick );
-}
-
-
-/**
- * if we are a NET_MASTER_SERVER or NET_PROXY_SERVER_ACTIVE update the connection list to accept new
- * connections (clients) also start the handsake for the new clients
+  this->handleDownstream( tick );
+  this->handleUpstream( tick );
+}
+
+
+/**
+ * @brief handles incoming connections
+ *
+ * if we are a NET_MASTER_SERVER or NET_PROXY_SERVER_ACTIVE update the connection list to accept new connections (clients)
+ * start and initialize the handsake for the new clients
  */
 void NetworkStream::updateConnectionList( )
@@ -360,72 +375,72 @@
   //check for new connections
 
-  NetworkSocket* tempNetworkSocket = serverSocket->getNewSocket();
-
-  // we got new network node
-  if ( tempNetworkSocket )
-  {
-    int clientId;
-    // if there is a list of free client id slots, take these
-    if ( freeSocketSlots.size() > 0 )
-    {
-      clientId = freeSocketSlots.back();
-      freeSocketSlots.pop_back();
-    }
-    else
-    {
-      clientId = 1;
-
-      for ( PeerList::iterator it = peers.begin(); it != peers.end(); it++ )
-        if ( it->first >= clientId )
-          clientId = it->first + 1;
-    }
-    peers[clientId].socket = tempNetworkSocket;
-
-
-    // create new handshake and init its variables
-    peers[clientId].handshake = new Handshake(this->pInfo->nodeType, clientId, this->networkGameManager->getUniqueID(), MessageManager::getInstance()->getUniqueID());
-    peers[clientId].handshake->setUniqueID(clientId);
-
-    peers[clientId].connectionMonitor = new ConnectionMonitor( clientId );
-    peers[clientId].userId = clientId;
-
-    PRINTF(0)("num sync: %d\n", synchronizeables.size());
-
-    // get the proxy server informations and write them to the handshake, if any (proxy)
-    assert( this->networkMonitor != NULL);
-    PeerInfo* pi = this->networkMonitor->getFirstChoiceProxy();
-    if( pi != NULL)
-    {
-      peers[clientId].handshake->setProxy1Address( pi->ip);
-    }
-    pi = this->networkMonitor->getSecondChoiceProxy();
-    if( pi != NULL)
-      peers[clientId].handshake->setProxy2Address( pi->ip);
-
-    // check if the connecting client should reconnect to a proxy server
-    peers[clientId].handshake->setRedirect(/*this->networkMonitor->isReconnectNextClient()*/false);
-
-    // the connecting node of course is a client
-    peers[clientId].nodeType = NET_CLIENT;
-    peers[clientId].ip = peers[clientId].socket->getRemoteAddress();
-
-
-    // check if there are too many clients connected (DEPRECATED: new: the masterserver sends a list of proxy servers)
-//     if ( clientId > SharedNetworkData::getInstance()->getMaxPlayer() )
-//     {
-// //       peers[clientId].handshake->setRedirect(true);
-// //
-// //       peers[clientId].handshake->doReject( "too many connections" );
-//       PRINTF(0)("Will reject client %d because there are to many connections!\n", clientId);
-//     }
-//     else
-//     {
-//       PRINTF(0)("New Client: %d\n", clientId);
-//     }
-    PRINTF(0)("New Client: %d\n", clientId);
-
-
-  }
-
+  NetworkSocket* tempNetworkSocket = NULL;
+  int userId;
+
+  if( this->clientSocket != NULL)
+  {
+    tempNetworkSocket = this->clientSocket->getNewSocket();
+
+    // we got new NET_CLIENT connecting
+    if ( tempNetworkSocket )
+    {
+      // determine the network node id
+      if ( freeSocketSlots.size() > 0 )
+      {
+        userId = freeSocketSlots.back();
+        freeSocketSlots.pop_back();
+      }
+      else
+      {
+        userId = 1;
+
+        for ( PeerList::iterator it = peers.begin(); it != peers.end(); it++ )
+          if ( it->first >= userId )
+            userId = it->first + 1;
+      }
+      // this creates a new entry in the peers list
+      peers[userId].socket = tempNetworkSocket;
+      peers[userId].nodeType = NET_CLIENT;
+
+      // handle the newly connected client
+      this->handleConnect(userId);
+
+      PRINTF(0)("New Client: %d\n", userId);
+    }
+  }
+
+
+  if( this->proxySocket != NULL)
+  {
+    tempNetworkSocket = this->proxySocket->getNewSocket();
+
+    // we got new NET_PROXY_SERVER_ACTIVE connecting
+    if ( tempNetworkSocket )
+    {
+      // determine the network node id
+      if ( freeSocketSlots.size() > 0 )
+      {
+        userId = freeSocketSlots.back();
+        freeSocketSlots.pop_back();
+      }
+      else
+      {
+        userId = 1;
+
+        for ( PeerList::iterator it = peers.begin(); it != peers.end(); it++ )
+          if ( it->first >= userId )
+            userId = it->first + 1;
+      }
+
+      // this creates a new entry in the peers list
+      peers[userId].socket = tempNetworkSocket;
+      peers[userId].nodeType = NET_PROXY_SERVER_ACTIVE;
+
+      // handle the newly connected proxy server
+      this->handleConnect(userId);
+
+      PRINTF(0)("New proxy connected: %d\n", userId);
+    }
+  }
 
 
@@ -446,35 +461,7 @@
       PRINTF(0)("Client is gone: %d (%s)\n", it->second.userId, reason.c_str());
 
-
-      // clean up the network data
-      it->second.socket->disconnectServer();
-      delete it->second.socket;
-      it->second.socket = NULL;
-
-      // remove the old connectin monitor
-      if ( it->second.connectionMonitor )
-        delete it->second.connectionMonitor;
-      it->second.connectionMonitor = NULL;
-
-      // remove the handshake
-      if ( it->second.handshake )
-        delete it->second.handshake;
-      it->second.handshake = NULL;
-
-      // and cleanup the user infos
-      for ( SynchronizeableList::iterator it2 = synchronizeables.begin(); it2 != synchronizeables.end(); it2++ )
-      {
-        (*it2)->cleanUpUser( it->second.userId );
-      }
-
-      NetworkGameManager::getInstance()->signalLeftPlayer(it->second.userId);
-
-      freeSocketSlots.push_back( it->second.userId );
-
-      PeerList::iterator delit = it;
+      this->handleDisconnect( it->second.userId);
+
       it++;
-
-      peers.erase( delit );
-
       continue;
     }
@@ -487,4 +474,43 @@
 
 
+/**
+ * this handles new connections
+ * @param userId: the id of the new user node
+ */
+void NetworkStream::handleConnect( int userId)
+{
+  // create new handshake and init its variables
+  peers[userId].handshake = new Handshake(this->pInfo->nodeType, userId, this->networkGameManager->getUniqueID(), MessageManager::getInstance()->getUniqueID());
+  peers[userId].handshake->setUniqueID(userId);
+
+  peers[userId].connectionMonitor = new ConnectionMonitor( userId );
+  peers[userId].userId = userId;
+
+  PRINTF(0)("num sync: %d\n", synchronizeables.size());
+
+  // get the proxy server informations and write them to the handshake, if any (proxy)
+  assert( this->networkMonitor != NULL);
+  PeerInfo* pi = this->networkMonitor->getFirstChoiceProxy();
+  if( pi != NULL)
+  {
+    peers[userId].handshake->setProxy1Address( pi->ip);
+  }
+  pi = this->networkMonitor->getSecondChoiceProxy();
+  if( pi != NULL)
+    peers[userId].handshake->setProxy2Address( pi->ip);
+
+  // check if the connecting client should reconnect to a proxy server
+  if( SharedNetworkData::getInstance()->isMasterServer())
+    peers[userId].handshake->setRedirect(/*this->networkMonitor->isReconnectNextClient()*/false);
+
+  // the connecting node of course is a client
+  peers[userId].ip = peers[userId].socket->getRemoteAddress();
+}
+
+
+
+/**
+ * some debug output
+ */
 void NetworkStream::debug()
 {
@@ -492,5 +518,5 @@
     PRINT(0)(" Host ist Master Server with ID: %i\n", this->pInfo->userId);
   }
-  else if( SharedNetworkData::getInstance()->isProxyServer()) {
+  else if( SharedNetworkData::getInstance()->isProxyServerActive()) {
     PRINT(0)(" Host ist Proxy Server with ID: %i\n", this->pInfo->userId);
   }
@@ -541,15 +567,25 @@
         if ( it->second.handshake->ok() )
         {
-          // the server gave it free for deletion
+          // write the first informations into the node so they can be read from there for case differentiation
+          it->second.nodeType = it->second.handshake->getRemoteNodeType();
+
+          // the counter part didn't mark it free for deletion yet
           if ( !it->second.handshake->allowDel() )
           {
-
-            if ( this->pInfo->isClient() )
+            // make sure this is a connection:
+            // - client       <==> master server
+            // - proxy server <==> master server
+            if(  SharedNetworkData::getInstance()->isClient() || SharedNetworkData::getInstance()->isProxyServerActive() && it->second.isMasterServer())
             {
+              PRINTF(0)("Handshake: i am in client role\n");
+
               SharedNetworkData::getInstance()->setHostID( it->second.handshake->getHostId() );
               this->pInfo->userId = SharedNetworkData::getInstance()->getHostID();
 
-              it->second.nodeType = it->second.handshake->getRemoteNodeType();
-              it->second.ip = it->second.socket->getRemoteAddress();
+#warning the ip address is not set here because it results in a segfault when connecting to a proxy server => trace this later
+//               it->second.ip = it->second.socket->getRemoteAddress();
+
+              // it->second.nodeType = it->second.handshake->getRemoteNodeType();
+              // it->second.ip = it->second.socket->getRemoteAddress();
               // add the new server to the nodes list (it can be a NET_MASTER_SERVER or NET_PROXY_SERVER)
               this->networkMonitor->addNode(&it->second);
@@ -560,6 +596,8 @@
 
               // now check if the server accepted the connection
-              if( it->second.handshake->redirect())
-                this->handleReconnect( it->second.userId);
+              if( SharedNetworkData::getInstance()->isClient() && it->second.handshake->redirect() )
+              {
+                this->bRedirect = true;
+              }
 
               // create the new network game manager and init it
@@ -570,7 +608,7 @@
             }
 
-
             PRINT(0)("handshake finished id=%d\n", it->second.handshake->getNetworkGameManagerId());
             it->second.handshake->del();
+
           }
           else
@@ -580,7 +618,6 @@
             {
 
-              if ( this->pInfo->isMasterServer() )
+              if (  SharedNetworkData::getInstance()->isMasterServer() )
               {
-                it->second.nodeType = it->second.handshake->getRemoteNodeType();
                 it->second.ip = it->second.socket->getRemoteAddress();
 
@@ -594,7 +631,8 @@
                 }
               }
-              else if ( this->pInfo->isProxyServer() )
+              else if ( SharedNetworkData::getInstance()->isProxyServerActive() && it->second.isClient() )
               {
-                it->second.nodeType = it->second.handshake->getRemoteNodeType();
+                PRINTF(0)("Handshake: i am in server role\n");
+
                 it->second.ip = it->second.socket->getRemoteAddress();
 
@@ -632,32 +670,66 @@
 void NetworkStream::handleReconnect(int userId)
 {
+  this->bRedirect = false;
+  PeerInfo* pInfo = &this->peers[userId];
+
   PRINTF(0)("===============================================\n");
   PRINTF(0)("Client is redirected to the other proxy servers\n");
+  PRINTF(0)("  user id: %i\n", userId);
+  PRINTF(0)("  connecting to: %s\n", this->networkMonitor->getFirstChoiceProxy()->ip.ipString().c_str());
   PRINTF(0)("===============================================\n");
-
-  return;
-
-  PeerInfo* pInfo = &this->peers[userId];
-
-  // reject the server
-  pInfo->handshake->doReject( "redirected to different server");
 
   // flush the old synchronization states, since the numbering could be completely different
   pInfo->lastAckedState = 0;
   pInfo->lastRecvedState = 0;
-  // not sure if this works as expected
-  if( pInfo->handshake)
-    delete pInfo->handshake;
+
+  // temp save the ip address here
+  IP proxyIP = pInfo->handshake->getProxy1Address();
 
   // disconnect from the current server and reconnect to proxy server
-  pInfo->socket->reconnectToServer( pInfo->handshake->getProxy1Address().ipString(), pInfo->handshake->getProxy1Address().port());
+  this->handleDisconnect( userId);
+  this->connectToProxyServer(NET_ID_PROXY_SERVER_01, proxyIP.ipString(), 9999);
+  #warning the ports are not yet integrated correctly in the ip class
 
   // and restart the handshake
-  this->startHandshake();
-}
+  this->startHandshake( userId);
+}
+
+
+/**
+ * handles the disconnect event
+ * @param userId id of the user to remove
+ */
+void NetworkStream::handleDisconnect( int userId )
+{
+  peers[userId].socket->disconnectServer();
+  delete peers[userId].socket;
+  peers[userId].socket = NULL;
+
+  if ( peers[userId].handshake )
+    delete peers[userId].handshake;
+  peers[userId].handshake = NULL;
+
+  if ( peers[userId].connectionMonitor )
+    delete peers[userId].connectionMonitor;
+  peers[userId].connectionMonitor = NULL;
+
+
+  for ( SynchronizeableList::iterator it2 = synchronizeables.begin(); it2 != synchronizeables.end(); it2++ )  {
+    (*it2)->cleanUpUser( userId );
+  }
+
+  if( SharedNetworkData::getInstance()->isMasterServer())
+    NetworkGameManager::getInstance()->signalLeftPlayer(userId);
+
+  this->freeSocketSlots.push_back( userId );
+
+  peers.erase( userId);
+}
+
 
 
 /**
  * handle upstream network traffic
+ * @param tick: seconds elapsed since last update
  */
 void NetworkStream::handleUpstream( int tick )
@@ -698,5 +770,5 @@
 
       // do not include synchronizeables with uninit id and syncs that don't want to be synchronized
-      if ( !sync.beSynchronized() || sync.getUniqueID() < 0 )
+      if ( !sync.beSynchronized() || sync.getUniqueID() <= NET_UID_UNASSIGNED )
         continue;
 
@@ -706,5 +778,7 @@
 
       // if we are a server (both master and proxy servers) and this is not our handshake
-      if ( ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer() ) && sync.getLeafClassID() == CL_HANDSHAKE && sync.getUniqueID() != peer->second.userId )
+      if ( ( SharedNetworkData::getInstance()->isMasterServer() ||
+             SharedNetworkData::getInstance()->isProxyServerActive() &&  peer->second.isClient())
+             && sync.getLeafClassID() == CL_HANDSHAKE && sync.getUniqueID() != peer->second.userId )
         continue;
 
@@ -720,5 +794,6 @@
 
       // server fakes uniqueid == 0 for handshake
-      if ( ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer() ) &&
+      if ( ( SharedNetworkData::getInstance()->isMasterServer() ||
+             SharedNetworkData::getInstance()->isProxyServerActive() &&  peer->second.isClient() ) &&
              sync.getUniqueID() <= SharedNetworkData::getInstance()->getMaxPlayer() + 1) // plus one to handle one client more than the max to redirect it
         n = Converter::intToByteArray( 0, buf + offset, UDP_PACKET_SIZE - offset );
@@ -760,5 +835,6 @@
       Synchronizeable & sync = **it;
 
-      if ( !sync.beSynchronized() || sync.getUniqueID() < 0 )
+      // again exclude all unwanted syncs
+      if ( !sync.beSynchronized() || sync.getUniqueID() <= NET_UID_UNASSIGNED)
         continue;
 
@@ -771,5 +847,6 @@
     // now compress the data with the zip library
     int compLength = 0;
-    if ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
+    if ( SharedNetworkData::getInstance()->isMasterServer() ||
+         SharedNetworkData::getInstance()->isProxyServerActive())
       compLength = Zip::getInstance()->zip( buf, offset, compBuf, UDP_PACKET_SIZE, dictServer );
     else
@@ -888,6 +965,10 @@
           }
 
-          // if the node we got this unknown sync from is a client we ignore it (since it has no rights to create a new sync)
-          if ( peers[peer->second.userId].isClient() )
+          // if the node we got this unknown sync we ignore it if:
+          //  - the remote host is a client
+          //  - the remote host is a proxy server and we are master server
+          // (since it has no rights to create a new sync)
+          if ( peers[peer->second.userId].isClient() ||
+               (peers[peer->second.userId].isProxyServerActive() && SharedNetworkData::getInstance()->isMasterServer()))
           {
             offset += syncDataLength;
@@ -960,5 +1041,5 @@
         Synchronizeable & sync = **it;
 
-        if ( !sync.beSynchronized() || sync.getUniqueID() < 0 )
+        if ( !sync.beSynchronized() || sync.getUniqueID() <= NET_UID_UNASSIGNED )
           continue;
 
Index: /trunk/src/lib/network/network_stream.h
===================================================================
--- /trunk/src/lib/network/network_stream.h	(revision 9493)
+++ /trunk/src/lib/network/network_stream.h	(revision 9494)
@@ -42,9 +42,9 @@
 
     void connectToMasterServer(std::string host, int port);
-    void connectToProxyServer(std::string host, int port);
-    void createServer(int port);
+    void connectToProxyServer(int proxyId, std::string host, int port);
+    void createServer(int clientPort, int proxyPort);
 
     void createNetworkGameManager();
-    void startHandshake();
+    void startHandshake(int userId = NET_ID_MASTER_SERVER);
 
     /* synchronizeable interface */
@@ -55,7 +55,13 @@
 
     /* functions for the peerInfo information retreival */
+    /** @returns true if this userId is activated at this client false if not*/
     inline bool isUserIdActive( int userID ) { return (peers.find(userID) != peers.end()); }
+    /** @returns true if this userId is a local client */
+    inline bool isUserLocal( int userID) { return this->isUserIdActive(userID); }
+    /** @returns true if this user is a master server */
     inline bool isUserMasterServer( int userID ){ if ( !isUserIdActive(userID) ) return false; return peers[userID].isMasterServer(); }
-    inline bool isUserProxyServer( int userID ){ if ( !isUserIdActive(userID) ) return false; return peers[userID].isProxyServer(); }
+    /** @returns true if this user is a proxy server */
+    inline bool isUserProxyServerActive( int userID ){ if ( !isUserIdActive(userID) ) return false; return peers[userID].isProxyServerActive(); }
+    /** @returns true if this user is a client */
     inline bool isUserClient( int userID ){ if ( !isUserIdActive(userID) ) return false; return peers[userID].isClient(); }
 
@@ -80,4 +86,5 @@
 
     void updateConnectionList();
+
     /* handle processes */
     void handleHandshakes();
@@ -87,5 +94,8 @@
     /* handle events*/
     void handleNewClient( int userId );
+
+    void handleConnect( int userId);
     void handleReconnect( int userId );
+    void handleDisconnect( int userId );
 
     void writeToNewDict( byte * data, int length, bool upstream );
@@ -102,5 +112,6 @@
     NetworkMonitor*            networkMonitor;              //!< the network monitor
     NetworkGameManager*        networkGameManager;          //!< reference to the network game manager
-    ServerSocket*              serverSocket;                //!< the listening socket of the server
+    ServerSocket*              clientSocket;                //!< the listening socket of the server
+    ServerSocket*              proxySocket;                 //!< socket for proxy connections
 
     std::map<int,int>          oldSynchronizeables;         //!< used to save recently deleted sync ids to not recreate them
@@ -113,4 +124,6 @@
     int                        dictServer;                  //!< the zip dict for the server
     int                        dictClient;                  //!< the zip dict for the client
+
+    bool                       bRedirect;                   //!< true if the master server sent a redirect command
 };
 #endif /* _NETWORK_STREAM */
Index: /trunk/src/lib/network/peer_info.cc
===================================================================
--- /trunk/src/lib/network/peer_info.cc	(revision 9493)
+++ /trunk/src/lib/network/peer_info.cc	(revision 9494)
@@ -54,18 +54,23 @@
 
 
-std::string PeerInfo::getNodeTypeString()
+const std::string& PeerInfo::getNodeTypeString() const
 {
-  switch( this->nodeType)
-  {
-    case NET_CLIENT:
-      return std::string("client");
-    case NET_PROXY_SERVER_ACTIVE:
-      return std::string("proxy server active");
-    case NET_PROXY_SERVER_PASSIVE:
-      return std::string("proxy server passive");
-    case NET_MASTER_SERVER:
-      return std::string("master server");
-  }
+  return PeerInfo::nodeTypeToString( this->nodeType );
+  // the above does the same, and is faster in it. (there is no case where node is uninit i hope!)
+}
 
-  return std::string("node is uninit");
+const std::string& PeerInfo::nodeTypeToString(unsigned int type)
+{
+  return PeerInfo::nodeNames[type];
 }
+
+
+const std::string PeerInfo::nodeNames[] =
+{
+
+  "maser server",
+  "proxy server active",
+  "proxy server passive",
+  "client",
+  "node is not initialized"
+};
Index: /trunk/src/lib/network/peer_info.h
===================================================================
--- /trunk/src/lib/network/peer_info.h	(revision 9493)
+++ /trunk/src/lib/network/peer_info.h	(revision 9494)
@@ -22,10 +22,12 @@
 
 
-    inline bool isMasterServer() { return this->nodeType == NET_MASTER_SERVER; }
-    inline bool isProxyServer() { return this->nodeType == NET_PROXY_SERVER_ACTIVE; }
-    inline bool isProxyServerPassive() { return this->nodeType == NET_PROXY_SERVER_PASSIVE; }
-    inline bool isClient() { return this->nodeType == NET_CLIENT; }
+    inline bool isMasterServer() const { return this->nodeType == NET_MASTER_SERVER; }
+    inline bool isProxyServerActive() const { return this->nodeType == NET_PROXY_SERVER_ACTIVE; }
+    inline bool isProxyServerActivePassive() const { return this->nodeType == NET_PROXY_SERVER_PASSIVE; }
+    inline bool isClient() const { return this->nodeType == NET_CLIENT; }
 
-    std::string getNodeTypeString();
+    const std::string& getNodeTypeString() const;
+    static const std::string& nodeTypeToString(unsigned int type);
+
 
 
@@ -41,4 +43,7 @@
     int                 lastAckedState;          //!< last acked state synchronized state
     int                 lastRecvedState;         //!< last received state
+
+    static const std::string nodeNames[];
+
 };
 
Index: /trunk/src/lib/network/player_stats.cc
===================================================================
--- /trunk/src/lib/network/player_stats.cc	(revision 9493)
+++ /trunk/src/lib/network/player_stats.cc	(revision 9494)
@@ -191,5 +191,5 @@
 void PlayerStats::setNickName( std::string nick )
 {
-  if ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer() )
+  if ( SharedNetworkData::getInstance()->isMasterServer())
   {
     this->nickName = nick;
Index: /trunk/src/lib/network/proxy/network_settings.cc
===================================================================
--- /trunk/src/lib/network/proxy/network_settings.cc	(revision 9493)
+++ /trunk/src/lib/network/proxy/network_settings.cc	(revision 9494)
@@ -40,6 +40,4 @@
   // suggest a good standard max players value
   this->maxPlayer = 10;
-
-//   this->loadData();
 }
 
@@ -53,9 +51,8 @@
 
   // remove all unused proxy data again
-  for( int i = 0; i < this->proxies.size(); i++)
+  for(unsigned int i = 0; i < this->proxies.size(); i++)
   {
-    IPaddress* ip = this->proxies.back();
+    IP ip = this->proxies.back();
     this->proxies.pop_back();
-    delete ip;
   }
 }
@@ -104,4 +101,5 @@
 
   LoadParam(root, "max-player", this, NetworkSettings, setMaxPlayer);
+  LoadParam(root, "max-player-saturation", this, NetworkSettings, setMaxPlayerSaturation);
 
 
@@ -140,9 +138,5 @@
     return;
 
-  IPaddress *ip = new IPaddress;
-
-  SDLNet_ResolveHost( ip, proxyAddr.c_str(), 9999 );
-
-  this->proxies.push_back(ip);
+  this->proxies.push_back(IP(proxyAddr, 9999));
 }
 
